/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.yoko.bindings.corba;

import java.net.URL;
import javax.xml.namespace.QName;

import org.objectweb.celtix.ws.addressing.EndpointReferenceType;
import org.objectweb.celtix.wsdl.EndpointReferenceUtils;

public final class TestUtils {
    
    public EndpointReferenceType getSimpleTestEndpointReference() {
        URL wsdlUrl = getClass().getResource("/wsdl/simpleIdl.wsdl");
        QName serviceName = new QName("http://yoko.apache.org/simple", "SimpleCORBAService");
        return EndpointReferenceUtils.getEndpointReference(wsdlUrl, serviceName, "SimpleCORBAPort");
    }
    
    public EndpointReferenceType getStaxTestEndpointReference() {
        URL wsdlUrl = getClass().getResource("/wsdl/StaxTest.wsdl");
        QName serviceName = new QName("http://yoko.apache.org/StaxTest", "StaxTestCORBAService");
        return EndpointReferenceUtils.getEndpointReference(wsdlUrl, serviceName, "StaxTestCORBAPort");
    }
    
    public EndpointReferenceType getComplexTypesEndpointReference() {
        URL wsdlUrl = getClass().getResource("/wsdl/ComplexTypes.wsdl");
        QName serviceName = new QName("http://yoko.apache.org/ComplexTypes", "ComplexTypesCORBAService");
        return EndpointReferenceUtils.getEndpointReference(wsdlUrl, serviceName, "ComplexTypesCORBAPort");
    }
    
    public EndpointReferenceType getParamModesEndpointReference() {
        URL wsdlUrl = getClass().getResource("/wsdl/ParamModes.wsdl");
        QName serviceName = new QName("http://yoko.apache.org/ParamModes", "ParamModesCORBAService");
        return EndpointReferenceUtils.getEndpointReference(wsdlUrl, serviceName, "ParamModesCORBAPort");
    }
    
    public EndpointReferenceType getNestedEndpointReference() {
        URL wsdlUrl = getClass().getResource("/wsdl/Nested.wsdl");
        QName serviceName = new QName("http://yoko.apache.org/nested", "NestedCORBAService");
        return EndpointReferenceUtils.getEndpointReference(wsdlUrl, serviceName, "NestedCORBAPort");
    }
}
