/*
 *  Copyright 2006 The Apache Software Foundation or its licensors, as applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.omg.CORBA;

abstract public class SystemException extends java.lang.RuntimeException {
    public int minor;

    public CompletionStatus completed;

    protected SystemException(String reason, int minor, CompletionStatus status) {
        super(reason);
        this.minor = minor;
        this.completed = status;
    }

    public String toString() {
        String s = super.toString() + "  minor code: 0x"
                + Integer.toHexString(minor);

        switch (completed.value()) {
        case CompletionStatus._COMPLETED_YES:
            s += "  completed: Yes";
            break;

        case CompletionStatus._COMPLETED_NO:
            s += "  completed: No";
            break;

        case CompletionStatus._COMPLETED_MAYBE:
        default:
            s += "  completed: Maybe";
            break;
        }

        return s;
    }
}
